--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			LSW CORE LIB: CURL - ERROR CODES EXTENSION
-- @author		Valentin Schmidt
-- @version	 0.1
--****************************************************************************

property CURLERRORS			-- see enum CURLcode in curl.h
property CURLMULTIERRORS -- see enum CURLMcode in multi.h

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

	err = []
	err[ 1] = "UNSUPPORTED_PROTOCOL"
	err[ 2] = "FAILED_INIT"
	err[ 3] = "URL_MALFORMAT"
	err[ 4] = "NOT_BUILT_IN"
	err[ 5] = "COULDNT_RESOLVE_PROXY"
	err[ 6] = "COULDNT_RESOLVE_HOST"
	err[ 7] = "COULDNT_CONNECT"
	err[ 8] = "FTP_WEIRD_SERVER_REPLY"
	err[ 9] = "REMOTE_ACCESS_DENIED"
	err[10] = "FTP_ACCEPT_FAILED"
	err[11] = "FTP_WEIRD_PASS_REPLY"
	err[12] = "FTP_ACCEPT_TIMEOUT"
	err[13] = "FTP_WEIRD_PASV_REPLY"
	err[14] = "FTP_WEIRD_227_FORMAT"
	err[15] = "FTP_CANT_GET_HOST"
	err[16] = "HTTP2"
	err[17] = "FTP_COULDNT_SET_TYPE"
	err[18] = "PARTIAL_FILE"
	err[19] = "FTP_COULDNT_RETR_FILE"
	err[20] = "OBSOLETE20"
	err[21] = "QUOTE_ERROR"
	err[22] = "HTTP_RETURNED_ERROR"
	err[23] = "WRITE_ERROR"
	err[24] = "OBSOLETE24"
	err[25] = "UPLOAD_FAILED"
	err[26] = "READ_ERROR"
	err[27] = "OUT_OF_MEMORY"
	err[28] = "OPERATION_TIMEDOUT"
	err[29] = "OBSOLETE29"
	err[30] = "FTP_PORT_FAILED"
	err[31] = "FTP_COULDNT_USE_REST"
	err[32] = "OBSOLETE32"
	err[33] = "RANGE_ERROR"
	err[34] = "HTTP_POST_ERROR"
	err[35] = "SSL_CONNECT_ERROR"
	err[36] = "BAD_DOWNLOAD_RESUME"
	err[37] = "FILE_COULDNT_READ_FILE"
	err[38] = "LDAP_CANNOT_BIND"
	err[39] = "LDAP_SEARCH_FAILED"
	err[40] = "OBSOLETE40"
	err[41] = "FUNCTION_NOT_FOUND"
	err[42] = "ABORTED_BY_CALLBACK"
	err[43] = "BAD_FUNCTION_ARGUMENT"
	err[44] = "OBSOLETE44"
	err[45] = "INTERFACE_FAILED"
	err[46] = "OBSOLETE46"
	err[47] = "TOO_MANY_REDIRECTS "
	err[48] = "UNKNOWN_OPTION"
	err[49] = "TELNET_OPTION_SYNTAX "
	err[50] = "OBSOLETE50"
	err[51] = "PEER_FAILED_VERIFICATION"
	err[52] = "GOT_NOTHING"
	err[53] = "SSL_ENGINE_NOTFOUND"
	err[54] = "SSL_ENGINE_SETFAILED"
	err[55] = "SEND_ERROR"
	err[56] = "RECV_ERROR"
	err[57] = "OBSOLETE57"
	err[58] = "SSL_CERTPROBLEM"
	err[59] = "SSL_CIPHER"
	err[60] = "SSL_CACERT"
	err[61] = "BAD_CONTENT_ENCODING"
	err[62] = "LDAP_INVALID_URL"
	err[63] = "FILESIZE_EXCEEDED"
	err[64] = "USE_SSL_FAILED"
	err[65] = "SEND_FAIL_REWIND"
	err[66] = "SSL_ENGINE_INITFAILED"
	err[67] = "LOGIN_DENIED"
	err[68] = "TFTP_NOTFOUND"
	err[69] = "TFTP_PERM"
	err[70] = "REMOTE_DISK_FULL"
	err[71] = "TFTP_ILLEGAL"
	err[72] = "TFTP_UNKNOWNID"
	err[73] = "REMOTE_FILE_EXISTS"
	err[74] = "TFTP_NOSUCHUSER"
	err[75] = "CONV_FAILED"
	err[76] = "CONV_REQD"
	err[77] = "SSL_CACERT_BADFILE"
	err[78] = "REMOTE_FILE_NOT_FOUND"
	err[79] = "SSH"
	err[80] = "SSL_SHUTDOWN_FAILED"
	err[81] = "AGAIN"
	err[82] = "SSL_CRL_BADFILE"
	err[83] = "SSL_ISSUER_ERROR"
	err[84] = "FTP_PRET_FAILED"
	err[85] = "RTSP_CSEQ_ERROR"
	err[86] = "RTSP_SESSION_ERROR"
	err[87] = "FTP_BAD_FILE_LIST"
	err[88] = "CHUNK_FAILED"
	err[89] = "NO_CONNECTION_AVAILABLE"
	err[90] = "SSL_PINNEDPUBKEYNOTMATCH"
	err[91] = "SSL_INVALIDCERTSTATUS"

	me.CURLERRORS = err
	
	err = []
	err[1] = "BAD_HANDLE"			-- the passed-in handle is not a valid CURLM handle
	err[2] = "BAD_EASY_HANDLE" -- an easy handle was not good/valid
	err[3] = "OUT_OF_MEMORY"	 -- if you ever get this, you're in deep sh*t
	err[4] = "INTERNAL_ERROR"	-- this is a libcurl bug
	err[5] = "BAD_SOCKET"			-- the passed in socket argument did not match
	err[6] = "UNKNOWN_OPTION"	-- curl_multi_setopt() with unsupported option
	err[7] = "ADDED_ALREADY"	 -- an easy handle already added to a multi handle was attempted to get added - again
	
	me.CURLMULTIERRORS = err
	
	return me
end