--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			Callback Detach Class
-- @author		Valentin Schmidt
-- @version	 0.2
--****************************************************************************

global $

property _method
property _receiver
property _ch
property _data

----------------------------------------
-- @constructor
----------------------------------------
on new (me, method, receiver, ch, customData)
	me._method = method
	me._receiver = receiver
	me._ch = ch
	me._data = customData
	return me
end

----------------------------------------
-- use 1 ms single-shot timeout to create a new thread
-- so scripting errors in callbacks don't fail silently
----------------------------------------
on _detach (me, res)
	$.detacher.detach(#_call, me, res)
end

----------------------------------------
-- we are detached from original thread, now handle signal
----------------------------------------
--on _call (me, res, ms)
--	call(me._method, me._receiver, res,  me._ch, me._data, ms)
--end
on _call (me, res)
	call(me._method, me._receiver, res,  me._ch, me._data)
end

----------------------------------------
-- use 1 ms single-shot timeout to create a new thread
-- so scripting errors in callbacks don't fail silently
----------------------------------------
--on _detachProgress (me, dltotal, dlnow, ultotal, ulnow)
--	$.detacher.detach(#_callProgress, me, [dltotal, dlnow, ultotal, ulnow])
--end
on _detachProgress (me, dltotal, dlnow, ultotal, ulnow)
	$.detacher.detach(#_callProgress, me, dltotal, dlnow, ultotal, ulnow)
end

----------------------------------------
-- we are detached from original thread, now handle signal
----------------------------------------
--on _callProgress (me, args, ms)
--	call(me._method, me._receiver, args[1],args[2],args[3],args[4],  me._ch, me._data, ms)
--end
on _callProgress (me, dltotal, dlnow, ultotal, ulnow)
	call(me._method, me._receiver, dltotal, dlnow, ultotal, ulnow,  me._ch, me._data)
end
